#ifndef SPRITE_H
#define SPRITE_H

#include "include/animat.h"
#include <tonc.h>

typedef struct Piece{
       int src_offset;
       int length;
  OBJ_ATTR data;
} Piece;

typedef struct Image{
  const Piece * piece_start;
            int piece_count;
} Image;

typedef struct SimplexSprite{
  OBJ_ATTR data;
       int origin_x;
       int origin_y;
} SimplexSprite;

typedef struct ComplexSprite{
  const unsigned int * image_src;
         const Image * draw_image;
		   const int * anim_image;
	     const Image * init_image;
                   int draw_count;
	               int origin_x;
	               int origin_y;
				   int flipped;
				   int width;
} ComplexSprite;

#define sprShadowM     0

#define sprLinkStandU  0
#define sprLinkStandD  1
#define sprLinkStandL  2
#define sprLinkStandR  3
#define sprLinkWalkU   4
#define sprLinkWalkD   5
#define sprLinkWalkL   6
#define sprLinkWalkR   7

void draw_sprite_simplex(int,int,int,int);
void init_sprite_complex(Animat *,int);
void draw_sprite_complex(Animat *,int,int);

#endif