#include <tonc.h>
#include "include/sprRaw.h"
#include "include/objLink.h"

OBJ_ATTR sprite_list[128];
int sprite_count = 0;

ObjLink Link;

#define CBB_0  0
#define SBB_0 28

int main(){
  irq_init(NULL);
  irq_add(II_VBLANK,NULL);
  oam_init(sprite_list,128);
  
  REG_BG0CNT= BG_CBB(CBB_0) | BG_SBB(SBB_0) | BG_REG_32x32;
  REG_BG0HOFS= 0;
  REG_BG0VOFS= 0;
  const TILE tile_quick = {
    {0x11111111, 0x11111111, 0x11111111, 0x11111111, 
     0x11111111, 0x11111111, 0x11111111, 0x11111111}
  };
  tile_mem[CBB_0][0] = tile_quick;
  pal_bg_bank[0][1]= RGB15(20,20,20);
  int j;
  SCR_ENTRY *pse = se_mem[SBB_0];
  for (j = 0; j < 1024; j++)
    *pse++= SE_PALBANK(0) | 0;
  
  REG_DISPCNT = DCNT_OBJ | DCNT_OBJ_1D | DCNT_MODE0 | DCNT_BG0;
  memcpy16(pal_obj_mem,sprDefaultPal,256);
  memcpy32(tile_mem[4],sprShadowTiles,16);
  
  Link_Create(&Link,120,64,0,270);
  
  while (TRUE){
    VBlankIntrWait();
    key_poll();
    oam_init(sprite_list,sprite_count);
    sprite_count = 0;
    Link_Step(&Link);
    Link_Draw(&Link);
    oam_copy(oam_mem,sprite_list,sprite_count);
  }
  
  return 0;
}