#include "include/objLink.h"
#include "include/sprite.h"
#include <tonc.h>

void Link_Create(ObjLink *Link,int x,int y,int pal,int dir){
  Object_Init(&(Link->obj),x,y,dir);
  Animat_Init(&(Link->ani),pal);
}

void Link_Step(ObjLink *Link){
  Object *obj = &(Link->obj);
  Animat *ani = &(Link->ani);
  obj->keyU = (key_is_down(KEY_UP) != 0);
  obj->keyD = (key_is_down(KEY_DOWN) != 0);
  obj->keyL = (key_is_down(KEY_LEFT) != 0);
  obj->keyR = (key_is_down(KEY_RIGHT) != 0);
  if (key_hit(KEY_L)){
    if (ani->palette > 0)
      ani->palette--;
  }
  else if (key_hit(KEY_R)){
    if (ani->palette < 3)
	  ani->palette++;
  }
  direction_set(obj);
  movement_norm(obj);
}

void Link_Draw(ObjLink *Link){
  Object *obj = &(Link->obj);
  Animat *ani = &(Link->ani);
  if ((obj->keyU || obj->keyD || obj->keyL || obj->keyR)){
    ani->image_speed = 0x0008;
    switch (obj->direction){
	  case 90:  init_sprite_complex(ani,sprLinkWalkU); break;
	  case 270: init_sprite_complex(ani,sprLinkWalkD); break;
	  case 180: init_sprite_complex(ani,sprLinkWalkL); break;
	  default:  init_sprite_complex(ani,sprLinkWalkR); break;
	}
  }
  else{
    ani->image_speed = 0x0001;
    switch (obj->direction){
	  case 90:  init_sprite_complex(ani,sprLinkStandU); break;
	  case 270: init_sprite_complex(ani,sprLinkStandD); break;
	  case 180: init_sprite_complex(ani,sprLinkStandL); break;
	  default:  init_sprite_complex(ani,sprLinkStandR); break;
	}
  }
  int x = obj->x >> 8;
  int y = obj->y >> 8;
  draw_sprite_complex(ani,x,y);
  draw_sprite_simplex(sprShadowM,5,x,y);
}